/**************************************************************************/
/*                                                                        */
/* Copyright (c) 2011, 2016 NoMachine, http://www.nomachine.com/.         */
/*                                                                        */
/* NXSSHFS, NX protocol compression and extensions to this software       */
/* are copyright of NoMachine. Redistribution and use of the present      */
/* software is allowed according to terms specified in the file LICENSE   */
/* which comes in the source distribution.                                */
/*                                                                        */
/* Check http://www.nomachine.com/licensing.html for applicability.       */
/*                                                                        */
/* NX and NoMachine are trademarks of Medialogic S.p.A.                   */
/*                                                                        */
/* All rights reserved.                                                   */
/*                                                                        */
/**************************************************************************/

#ifndef DokanClient_H
#define DokanClient_H

#include "Debug.h"
#include "Types.h"
#include "CallBacks.h"
#include "Options.h"
#include "dokan.h"

//
// Map dokan error code to error message.
//

struct DokanErrorCode
{
  Int code_;

  const Char *name_;
};

typedef int (DOKANAPI *DokanMainPtr)(PDOKAN_OPTIONS, PDOKAN_OPERATIONS);

typedef BOOL (DOKANAPI *DokanRemoveMountPointPtr)(LPCWSTR MountPoint);

Int LoadDokanLibrary();

void FreeDokanLibrary();

Int SetupDokanCallbacks(const wchar_t *mountPoint);

DWORD WINAPI WaitForMount(const wchar_t *mountPoint);

Int UnmountDrive(const wchar_t *mountPoint);

#endif
