/**************************************************************************/
/*                                                                        */
/* Copyright (c) 2011, 2016 NoMachine, http://www.nomachine.com/.         */
/*                                                                        */
/* NXSSHFS, NX protocol compression and extensions to this software       */
/* are copyright of NoMachine. Redistribution and use of the present      */
/* software is allowed according to terms specified in the file LICENSE   */
/* which comes in the source distribution.                                */
/*                                                                        */
/* Check http://www.nomachine.com/licensing.html for applicability.       */
/*                                                                        */
/* NX and NoMachine are trademarks of Medialogic S.p.A.                   */
/*                                                                        */
/* All rights reserved.                                                   */
/*                                                                        */
/**************************************************************************/

#ifndef Options_H
#define Options_H

#undef STRING

#include "Types.h"
#include "String.h"
#include "Debug.h"
#include "Utils.h"

#include <windows.h>
#include <shellapi.h>

#define CMD_ARGS_MAX 8191

enum OptionsMode
{
  ERROR_MODE = -1,
  MOUNT_MODE = 0,
  UNMOUNT_MODE
};

struct OptionsStruct
{
  OptionsMode mode_;
  
  Int error_;
  
  Int slaveMode_;
  
  //
  // Data neccesery to connect to ssh client.
  //
  
  Char *user_;
  Char *host_;
  Char *keyfile_;
  Char password_[128];
  
  Int port_;
  
  //
  // Optionally caller passed stdin, stdout, 
  // stderr handles.
  //
  
  HANDLE stdinHandle_;
  HANDLE stdoutHandle_;
  HANDLE stderrHandle_;
  HANDLE reconnHandle_;
  
  //
  // Parent PID to synchronize with NX session.
  //
  
  Int parentPid_;
  
  //
  // Remote path to mount.
  //
  
  wchar_t remoteRoot_[MAX_PATH];

  //
  // Local path, where to mount.
  //
  
  wchar_t localRoot_[MAX_PATH];

  const Char* localRootA_;
  
  //
  // Extra arguments passed to run child ssh.
  //
  
  Int sshArgsCount_;

  Char **sshArgs_;

  //
  // Timeout for reading packets from server.
  //
  
  Int timeout_;


  Int parseArguments(Int argc, Char **argv);
  
  OptionsStruct();
  ~OptionsStruct();
};

#endif
