/**************************************************************************/
/*                                                                        */
/* Copyright (c) 2012, 2016 NoMachine, http://www.nomachine.com/.         */
/*                                                                        */
/* NXSSHFS, NX protocol compression and extensions to this software       */
/* are copyright of NoMachine. Redistribution and use of the present      */
/* software is allowed according to terms specified in the file LICENSE   */
/* which comes in the source distribution.                                */
/*                                                                        */
/* Check http://www.nomachine.com/licensing.html for applicability.       */
/*                                                                        */
/* NX and NoMachine are trademarks of Medialogic S.p.A.                   */
/*                                                                        */
/* All rights reserved.                                                   */
/*                                                                        */
/**************************************************************************/

#undef ERROR
#undef STRING

#include "String.h"
#include "Sftp.h"
#include "Utils.h"

//
// "statvfs@openssh.com" extension.
//

SftpStatvfsMsg::SftpStatvfsMsg(Int id, const Char *path)
{
  Int pathSize = StringLength(path);
    
  type_        = SSH2_FXP_EXTENDED;
  id_          = id;
  extNameSize_ = InvertBytes(sizeof("statvfs@openssh.com") - 1);
  pathSize_    = InvertBytes(pathSize);
    
  strcpy(extName_, "statvfs@openssh.com");
  memcpy(path_, path, pathSize);
    
  size_ = sizeof(size_) + sizeof(type_) + sizeof(id_) + sizeof(extNameSize_)
        + sizeof(extName_) + sizeof(pathSize_) + pathSize;
};

//
// Custom NX request:
//
// <request name> <target path>
//

SftpNxMsg::SftpNxMsg(Int id, const Char *name, const Char *path)
{
  Int pathSize = StringLength(path);
  Int nameSize = StringLength(name);
    
  type_        = SSH2_FXP_EXTENDED;
  id_          = id;
  extNameSize_ = InvertBytes(sizeof(extName_));
  pathSize_    = InvertBytes(pathSize);
    
  strncpy(extName_, name, sizeof(extName_));
  
  memcpy(path_, path, pathSize);
    
  size_ = sizeof(size_) + sizeof(type_) + sizeof(id_) + sizeof(extNameSize_)
        + sizeof(extName_) + sizeof(pathSize_) + pathSize;
};
